#include"tunables.h"

#ifndef SYSINCLUDES
#define SYSINCLUDES

#include<stdio.h>
#include<signal.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<sys/time.h>
#include<sys/ioctl.h>
#include"bsdsyslog.h"
#ifdef SYSV
#include <sgtty.h>
#include<string.h>
#include<fcntl.h>
#endif SYSV
#include<sys/file.h>
#ifndef SYSV
#include<strings.h>
#include<sys/un.h>
#include<netinet/tcp.h>
#include<arpa/inet.h>
#endif SYSV
#include<netinet/in.h>
#include<netdb.h>
#include<ctype.h>
#include<pwd.h>
#include<sys/stat.h>
#endif

#include"../Glib/Glib.h"
#include"video_conf.h"
#include"rpd_driver.h"
#include"swtr_driver.h"
#include"models.h"
/* HP-UX won't let me include termio.h and sgtty.h well */
#ifndef PARENB
#define PARENB 0001000
#endif
#ifndef PARODD
#define PARODD 0002000
#endif
#ifndef TCFLSH
#define TCFLSH  _IO(T,7)
#endif TCFLSH

#define USED 1
#define UNUSED 0
#define BUSY 0
#define NOT_BUSY 1
#define AVAILABLE 2

/* the number is actually the rev * 10 so that its an int */
#define SERVER_REVISION 20
#define PROTOCOL_REVISION 22

#define QUERY "areyouthere"
#define RESPONSE "imhere"
#define UNIX_STRING "UNIX connection"

typedef struct {
  char volume[30];
  int type;
  int resource[10];
  int output;
  int num_resources;
  int cur_resource;
  int index_state;
} DeviceList;

typedef struct {
  int switcher;
  int channel;
} Output;

#ifdef SEAMLESS
#define SEAMLESS_NAME "Seamless"
typedef struct _command {
  struct timeval time;  /* elapsed time correponding to frame */
  int action;    	/* SEARCH, ROLL, SWITCH, or RELEASE */
  int argument;    	/* argument to action */
  int argument2;        /* secondary argument */
  int volume;
  int resource; 
  RPD_ptr rpd;		
  Output out;
  struct _command *next;    /* next list item */
} command;
#endif SEAMLESS

#ifdef SIGGRAPH
#define SIGGRAPH_NAME "SIGGRAPH"
typedef struct Reservation {
  long begin;
  long end;
  int id;
  char volume[30];
  int output;
  int used;
} Reservation;

#endif SIGGRAPH

typedef struct {
  char address[30];
  int volume_revision;
} Client;

typedef struct {
  char name[30];
  int fd;
} Forward;

